"use strict";

this.name        = "Pi-Forty-Two Con stores"; 
this.author      = "spara"; //heavily modified from the original by Ark.
this.copyright   = "2009 - 2016 the Oolite team."; 
this.description = "This script places constore stations near witchspace boys and also one asteroid billboard when the populator can not add at least one of them.";

this.$conStores = true;//spawn constores
this.$asteroidBillBoards = true;//spawn asteroid billboards
this.$noFuel = true;//block selling fuel at constores

this.systemWillPopulate = function() {
	if (this.$conStores && system.government > 0 && system.population > 40) {
		var conStores = Ship.keysForRole("constore");
		var conStoreInd = Math.floor(system.pseudoRandomNumber * conStores.length);
		var conStoreKey = conStores[conStoreInd];
		//add a little randomization to the position.
		var exactPosition = Vector3D(0, 5E3, -30E3).add([system.scrambledPseudoRandomNumber(321) * 8E3, system.scrambledPseudoRandomNumber(425) * 8E3, system.scrambledPseudoRandomNumber(847) * 8E3]);
		system.setPopulator("con_store", {
			callback: function(pos) {
				var addedShip = system.addShips("[" + conStoreKey + "]", 1, pos, 0)[0];
				addedShip.orientation = [1, 0, 1, 0]; // Orientate the side to the main planet for best view from the spacelane.
				system.addShips("constore-buoy", 1, pos.add(addedShip.heading.multiply(10E3)), 0);
			}.bind(this),
			location: "COORDINATES",
			coordinates: exactPosition,
			deterministic: true
		});
	}
	
	if (this.$asteroidBillBoards && system.government === 7) {
		var planetToSun = system.sun.position.distanceTo(system.mainPlanet.position) - system.sun.radius - system.mainPlanet.radius;
		var spawnFraction = Math.random() * 0.5 + 0.25;
		//this is just a rough position for the populator callback, inside I'll use addShipToRoute instead.
		exactPosition = Vector3D(0, 0, spawnFraction * planetToSun).fromCoordinateSystem("spm");
		system.setPopulator("con_store_asteroid_billboard", {
			callback: function(pos) {
				var billboard = system.addShipsToRoute("asteroid-billboard", 1, spawnFraction, 'sp')[0];
				system.addShips("asteroid", 8, billboard.position, 10E3);
				billboard.orientation = Quaternion.random();	
			}.bind(this),
			location: "COORDINATES",
			coordinates: exactPosition
		});		
	}
}

this.guiScreenChanged = function(to, from) {
	if (guiScreen === "GUI_SCREEN_EQUIP_SHIP" && player.ship.docked && player.ship.dockedStation.hasRole("constore") && this.$noFuel) {
		mission.runScreen({
			title: "Staff only",
			message: "Apologies for the inconvenience. Our shipyard is very small and its facilities are exclusively for our own needs.",
			background: "yah_no_entry.png"
		});
	}
}

