"use strict";

this.name        = "yah_constore";
this.description = "ship script for constores";

this.shipSpawned = function() {
	//spawn a patrol (1-2 ships) around the station
	var count = 1 + Math.floor(Math.random() * 2);
	var shipdata = Ship.shipDataForKey(ship.dataKey);
	var defenseShip = shipdata["defense_ship_role"];
	var patrol = system.addShips(defenseShip, count, ship.position, 25E3);
	for (var i = 0; i < patrol.length; i++) {
		ship.group.addShip(patrol[i]);
		patrol[i].group = ship.group;
		patrol[i].switchAI("yah_patrolAI.js");
		patrol[i].forwardWeapon = "EQ_WEAPON_BEAM_LASER";
	}
	//for Oolite 1.80 and earlier
	//tame the wacky market by altering quantities.
	if (oolite.compareVersion("1.80") >= 0) {
		var maxProfit = 1000;//desicredits! How much profit is allowed for a single commodity when trading with the main station.
		var commodities  = ["food","textiles","radioactives","slaves","liquor_wines","luxuries","narcotics","computers","machinery","alloys","firearms","furs","minerals","gold","platinum","gem_stones","alien_items"];
		var systemMarket = system.mainStation.market;
		for (var i = 0; i < commodities.length; i++) {
			var commodity = commodities[i];
			var priceDiff = ship.market[commodity].price - systemMarket[commodity].price;
			//we'll make too much, over maxProfit, profit  selling to the constore.
			if (priceDiff > maxProfit / 127) {
				//cap the quantity so that the possible profit won't go over maxProfit.
				var quantityMin = 127 - Math.floor(maxProfit/priceDiff);
				//change the quantity only if needed.
				if (ship.market[commodity].quantity < quantityMin) {
					//recalculate quantity with flat distribution.
					var newQuantity = 127 - Math.ceil(Math.random() * (127 - quantityMin));
					ship.setMarketQuantity(commodity, newQuantity);
				}
			}
			//we'll make too much, over maxProfit, profit buying from the constore.
			else if (priceDiff < -1 * maxProfit / 127) {
				//cap the quantity so that possible profit won't go over maxProfit.
				var quantityMax = Math.floor(maxProfit/(-1 * priceDiff));
				//change the quantity only if needed.
				if (ship.market[commodity].quantity > quantityMax) {
					//recalculate quantity with flat distribution.
					var newQuantity = Math.ceil(Math.random() * (quantityMax));
					ship.setMarketQuantity(commodity, newQuantity);
				}
			}
		}
	}
}

//this makes the station behave very aggressively, if a ship in it's group is attacked
this.helpRequestReceived = function(ally, enemy) {
	//tame the behavior a bit
	if (Math.random() < 0.33) {
		ship.launchDefenseShip();
	}
}
