"use strict";

this.name = "yah-market";
this.author = "spara";
this.copyright = "2015 spara";
this.license     = "CC BY-NC-SA 4.0"; 

this.$originalDefs = {
      "food" : [0, 0, 22, -4, -4, 2, 1, 0, 0],
      "textiles" : [0, 0, 22, -4, -4, 2, 1, 0, 0],
      "radioactives" : [0, 0, 78, -4, -4, 2, 1, 0, 0],
      "slaves" : [0, 0, 20, -4, -4, 20, 1, 2, 0],
      "liquor_wines" : [0, 0, 108, -4, -4, 2, 1, 0, 0],
      "luxuries" : [0, 0, 235, -4, -4, 2, 1, 0, 0],
      "narcotics" : [0, 0, 282, -4, -4, 2, 1, 0, 0],
      "computers" : [0, 0, 185, -4, -4, 2, 1, 0, 0],
      "machinery" : [0, 0, 140, -4, -4, 2, 1, 0, 0],
      "alloys" : [0, 0, 94, -4, -4, 2, 1, 0, 0],
      "firearms" : [0, 0, 149, -4, -4, 2, 1, 0, 0],
      "furs" : [0, 0, 211, -4, -4, 2, 1, 0, 0],
      "minerals" : [0, 0, 38, -4, -4, 2, 1, 0, 0],
      "gold" : [0, 0, 65, -4, -4, 2, 1, 0, 1],
      "platinum" : [0, 0, 128, -4, -4, 2, 1, 0, 1],
      "gem_stones" : [0, 0, 34, -4, -4, 2, 1, 0, 2],
      "alien_items" : [0, 0, 80, -4, -4, 2, 1, 0, 0]
};

this.updateLocalCommodityDefinition = function(goodDefinition) {
	var commodity = goodDefinition.key;
	var oldDefs = this.$originalDefs[commodity];
	
	//this is a small market with extremely wacky prices and to respect the original author the market always has 10 items for sale.
	goodDefinition.capacity = 15;
	
	//old style definition found for the good. calculate it the old way
	if (oldDefs) {
		var market_base_price = oldDefs[2];
		var market_eco_adjust_price = oldDefs[3];
		var market_eco_adjust_quantity = oldDefs[4];
		var market_base_quantity = oldDefs[5];
		var market_mask_price = oldDefs[6];
		var market_mask_quantity = oldDefs[7];
		var market_rnd = Math.floor(Math.random() * 256);

		var economy = system.economy;
		
		var price = (market_base_price + (market_rnd & market_mask_price) + (economy * market_eco_adjust_price)) & 255;
		price *= 0.4;
		
		var quantity = (market_base_quantity + (market_rnd & market_mask_quantity) - (economy * market_eco_adjust_quantity)) & 255;
		if (quantity > 127) quantity = 0;
		
		quantity &= goodDefinition.capacity;//was 63
		
		goodDefinition.quantity = quantity;
		goodDefinition.price = price * 10;
	}
	//no definition found. just add some variance to the system market (+/-5%)
	else {
		goodDefinition.price = goodDefinition.price * (1.05 - Math.random() * 0.1);
		goodDefinition.quantity = Math.floor(goodDefinition.quantity * (1.05 - Math.random() * 0.1));
	}
	//scale down if quantity too high
	if (goodDefinition.quantity > goodDefinition.capacity)
		goodDefinition.quantity = Math.floor(goodDefinition.quantity / 127 * goodDefinition.capacity);

	//now we'll tame the market from producing too much profit.
	var maxProfit = 1000;//desicredits! How much profit is allowed for a single commodity when trading with the main station.
	var sPrice = system.mainStation.market[commodity].price;
	var priceDiff = goodDefinition.price - sPrice;
	//we'll make too much profit selling to the constore.
	if (priceDiff > maxProfit / goodDefinition.capacity) {
		//cap the quantity so that the possible profit won't go over maxProfit.
		var quantityMin = goodDefinition.capacity - Math.floor(maxProfit/priceDiff);
		//change the quantity only if needed.
		if (goodDefinition.quantity < quantityMin) {
			//recalculate quantity with flat distribution.
			var newQuantity = goodDefinition.capacity - Math.ceil(Math.random() * (goodDefinition.capacity - quantityMin));
			goodDefinition.quantity = newQuantity;
		}
	}
	//we'll make too much profit buying from the constore.
	else if (priceDiff < -1 * maxProfit / goodDefinition.capacity) {
		//cap the quantity so that possible profit won't go over maxProfit.
		var quantityMax = Math.floor(maxProfit/(-1 * priceDiff));
		//change the quantity only if needed.
		if (goodDefinition.quantity > quantityMax) {
			//recalculate quantity with flat distribution.
			var newQuantity = Math.ceil(Math.random() * (quantityMax));
			goodDefinition.quantity = newQuantity;
		}
	}
	return goodDefinition;
};
